﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Personal
{
    class Print
    {
        public void PrintDataGrid(DataGridView dvg, string Header,string Fotter)
        {
            Date_ dt = new Date_();
            string d = dt.Curent_Day_Week() + dt.Curent_Day() + dt.Cutent_month_String() + dt.Curent_Year();
            Fotter = "نرم افزار جامع واحد بهره برداری" + "\n" + "برنامه نویس سعید شهسواری" + "\n"+d;
            DGVPrinter printer = new DGVPrinter();
            printer.CellAlignment = StringAlignment.Center;
            printer.CellFormatFlags = StringFormatFlags.DirectionRightToLeft;

            printer.HeaderCellAlignment = StringAlignment.Center;
            printer.HeaderCellFormatFlags = StringFormatFlags.DirectionRightToLeft;
            printer.PageNumberAlignment = StringAlignment.Near;
            printer.PageNumberInHeader = true;
            printer.PageNumberOnSeparateLine = true;
            printer.PageNumbers = true;
            printer.PorportionalColumns = true;

            printer.Title = Header;
            printer.TitleAlignment = StringAlignment.Center;
            printer.TitleColor = Color.Blue;
            printer.TitleFont = new Font("B Nazanin", 14);
            printer.TitleFormatFlags = StringFormatFlags.DirectionRightToLeft;

            printer.SubTitle = " ";
            printer.SubTitleAlignment = StringAlignment.Center;
            printer.SubTitleColor = Color.Blue;
            printer.SubTitleFont = new Font("B Nazanin", 50);
            printer.SubTitleFormatFlags = StringFormatFlags.DirectionRightToLeft;

            printer.Footer = Fotter;
            printer.FooterAlignment = StringAlignment.Center;
            printer.FooterColor = Color.Blue;
            printer.FooterFont = new Font("B Nazanin", 14);
            printer.FooterFormatFlags = StringFormatFlags.DirectionRightToLeft;
            printer.FooterSpacing = 10;

            printer.PrintPreviewDataGridView(dvg);
           
            

           }
    }
}
