﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Collections;
using System.Data;
using System.Data.OleDb;
using dotnetCHARTING.WinForms;
using Microsoft.Office.Tools.Excel;

namespace Personal
{
    public partial class frm_DatEntry_ISO : Form
    {
        ConnectionClass con = new ConnectionClass();
        double f1, f2, f3, f4;
        string Provider;
        string type_ = "No";
        SeriesCollection SC = new SeriesCollection();
        Series s = new Series();
        public frm_DatEntry_ISO(string perno)
        {
            InitializeComponent();
            Provider = perno;
        }
        private void frm_DatEntry_ISO_Load(object sender, EventArgs e)
        {
            desiner.Text = con.Back_Query("SELECT FAMILY FROM LOGIN WHERE PER='" + Provider + "'");
            string part = con.Back_Query("SELECT part FROM info WHERE PER='" + Provider + "'");
            con.View("select des as[اهداف خرد],point as[هدف] from  Point_ISO where part='" + part + "'", dataGridView1);
            if(Provider=="313064")
                con.View("select des as[اهداف خرد],point as[هدف] from  Point_ISO ", dataGridView1);
            dataGridView1.Columns[1].Width = 50;
            //=============================
            System.Globalization.PersianCalendar x = new System.Globalization.PersianCalendar();
            x.GetYear(System.DateTime.Now);
            txt_date.Text = x.GetYear(System.DateTime.Now).ToString() + "/" + x.GetMonth(System.DateTime.Now).ToString() + "/" + x.GetDayOfMonth(System.DateTime.Now).ToString();
            //================================
            txt_month.Items.Add("فروردین");
            txt_month.Items.Add("اردیبهشت");
            txt_month.Items.Add("خرداد");
            txt_month.Items.Add("تیر");
            txt_month.Items.Add("مرداد");
            txt_month.Items.Add("شهریور");
            txt_month.Items.Add("مهر");
            txt_month.Items.Add("آبان");
            txt_month.Items.Add("آذر");
            txt_month.Items.Add("دی");
            txt_month.Items.Add("بهمن");
            txt_month.Items.Add("اسفند");
        }
        private void dataGridView1_CellClick(object sender, DataGridViewCellEventArgs e)
        {
            chart1.Height = chart1.Height--;
            chart1.Width = chart1.Width--;

            kryptonDataGridView1[0, 0].Value = dataGridView1[1, dataGridView1.CurrentRow.Index].Value.ToString();
            lbl_formula.Text = con.Back_Query("select Furmola from point_iso where des='" + dataGridView1[0, dataGridView1.CurrentRow.Index].Value.ToString() + "'"); ;//
            type_ = con.Back_Query("select type_furmola from point_iso where des='" + dataGridView1[0, dataGridView1.CurrentRow.Index].Value.ToString() + "'");
            lbl_Des.Text = dataGridView1[0, dataGridView1.CurrentRow.Index].Value.ToString();
            con.View("select month_ as[ماه],offset as [انحراف] from info_Iso where des='" + lbl_Des.Text + "'", kryptonDataGridView2);
            txt_Analiz.Text=con.Back_Query("select analiz from info_Iso where des='" + lbl_Des.Text + "'");
            txt_Eghdam.Text = con.Back_Query("select eghdam from info_Iso where des='" + lbl_Des.Text + "'"); 
            //Chart Propertis
            chart1.PrinterOptimizedText=true;
            chart1.TitleBox.Label.Text = lbl_Des.Text;
            chart1.SeriesCollection.Clear();
            chart1.Use3D = true;
            chart1.ShadingEffectMode = ShadingEffectMode.Two;
            chart1.DefaultSeries.ConnectionString = con.ConnectionString;
            chart1.DateGrouping = TimeInterval.Month;
            chart1.Series.SqlStatement = "select month_ as[ماه],offset as [انحراف] from info_Iso where des='" + lbl_Des.Text + "'";
            chart1.Series.Type = SeriesType.Column;
            chart1.SeriesCollection.Add();
        }
        private void kryptonDataGridView1_CellLeave(object sender, DataGridViewCellEventArgs e)
        {
            if (type_ == "No")
                MessageBox.Show("نوع هدف را مشخص نمائید");
            else
            {
                if (e.ColumnIndex == 4)
                {
                    f1 = double.Parse(kryptonDataGridView1[0, 0].Value.ToString());
                    f2 = double.Parse(kryptonDataGridView1[1, 0].Value.ToString());
                    if (type_ == "1")
                        kryptonDataGridView1[2, 0].Value = Math.Round((f1 / f2), 4).ToString();
                    if (type_ == "2")
                        kryptonDataGridView1[2, 0].Value = Math.Round((1 - (f1 / f2)) * 100, 4).ToString();
                    if (type_ == "3")
                        kryptonDataGridView1[2, 0].Value = Math.Round(((f1 / f2) * 100), 4).ToString();
                    f3 = double.Parse(kryptonDataGridView1[2, 0].Value.ToString());
                    f4 = double.Parse(kryptonDataGridView1[3, 0].Value.ToString());
                    kryptonDataGridView1[4, 0].Value = (f4 - f3).ToString();
                }
            }
        }
        private void kryptonDataGridView2_CellClick(object sender, DataGridViewCellEventArgs e)
        {

                kryptonDataGridView1[0, 0].Value = con.Back_Query("select p1 from info_iso where des='" + lbl_Des.Text + "' and month_='" + kryptonDataGridView2[0, kryptonDataGridView2.CurrentRow.Index].Value.ToString() + "'");
                kryptonDataGridView1[1, 0].Value = con.Back_Query("select p2 from info_iso where des='" + lbl_Des.Text + "' and month_='" + kryptonDataGridView2[0, kryptonDataGridView2.CurrentRow.Index].Value.ToString() + "'");
                kryptonDataGridView1[2, 0].Value = con.Back_Query("select shakhes from info_iso where des='" + lbl_Des.Text + "' and month_='" + kryptonDataGridView2[0, kryptonDataGridView2.CurrentRow.Index].Value.ToString() + "'");
                kryptonDataGridView1[3, 0].Value = con.Back_Query("select point from info_iso where des='" + lbl_Des.Text + "' and month_='" + kryptonDataGridView2[0, kryptonDataGridView2.CurrentRow.Index].Value.ToString() + "'");
                kryptonDataGridView1[4, 0].Value = con.Back_Query("select offset from info_iso where des='" + lbl_Des.Text + "' and month_='" + kryptonDataGridView2[0, kryptonDataGridView2.CurrentRow.Index].Value.ToString() + "'");
                txt_Eghdam.Text = con.Back_Query("select eghdam from info_iso where des='" + lbl_Des.Text + "' and month_='" + kryptonDataGridView2[0, kryptonDataGridView2.CurrentRow.Index].Value.ToString() + "'"); ;
                txt_Analiz.Text = con.Back_Query("select analiz from info_iso where des='" + lbl_Des.Text + "' and month_='" + kryptonDataGridView2[0, kryptonDataGridView2.CurrentRow.Index].Value.ToString() + "'");

                chart1.Height = chart1.Height--;
                chart1.Width = chart1.Width--;
                chart1.YAxis.Minimum = double.Parse(con.Back_Query("select min(offset)from info_iso where des='" + lbl_Des.Text + "' and month_='" + kryptonDataGridView2[0, kryptonDataGridView2.CurrentRow.Index].Value.ToString() + "'")) - 0.5;
                chart1.YAxis.Maximum = double.Parse(con.Back_Query("select max(shakhes)from info_iso where des='" + lbl_Des.Text + "' and month_='" + kryptonDataGridView2[0, kryptonDataGridView2.CurrentRow.Index].Value.ToString() + "'")) + 0.5;

                chart1.SeriesCollection.Clear();
                chart1.Use3D = true;
                chart1.ShadingEffectMode = ShadingEffectMode.Two;
                chart1.DefaultSeries.ConnectionString = con.ConnectionString;
                chart1.DateGrouping = TimeInterval.Month;
                chart1.Series.SqlStatement = "select Shakhes as[شاخص],point as[هدف],offset as[انحراف] from info_iso where des='" + lbl_Des.Text + "' and month_='" + kryptonDataGridView2[0, kryptonDataGridView2.CurrentRow.Index].Value.ToString() + "'";
                chart1.Series.Type = SeriesType.Column;
                chart1.SeriesCollection.Add();


        }
        private void buttonX2_Click(object sender, EventArgs e)
        {
            if ((kryptonDataGridView1[0, 0].Value == null) || (kryptonDataGridView1[1, 0].Value == null) || (kryptonDataGridView1[2, 0].Value == null) || (txt_month.Text == "") || (txt_Eghdam.Text == "") || (txt_Analiz.Text == ""))
                MessageBox.Show("تمامی فبلدها بایدتکمیل شود", "خطای ثبت", MessageBoxButtons.OK, MessageBoxIcon.Information);
            else
            {
                if (con.Back_Query("select offset from info_Iso where month_='" + txt_month.Text + "' and des='" + lbl_Des.Text + "'") == "error")
                {
                    try
                    {
                        con.ExecuteNonQuery("insert into info_Iso values('" + txt_date.Text + "','" + desiner.Text + "','" + txt_month.Text + "','" + lbl_Des.Text + "','" + kryptonDataGridView1[0, 0].Value.ToString() + "','" + kryptonDataGridView1[1, 0].Value.ToString() + "','" + kryptonDataGridView1[2, 0].Value.ToString() + "','" + txt_Eghdam.Text + "','" + txt_Analiz.Text + "')");
                        kryptonDataGridView1[0, 0].Value = ""; kryptonDataGridView1[1, 0].Value = "";
                        kryptonDataGridView1[2, 0].Value = "";
                    }
                    catch
                    {
                        MessageBox.Show("داده های ورودی معتبر نمی باشد", "خطای ثبت", MessageBoxButtons.OK, MessageBoxIcon.Information);
                    }
                    txt_Analiz.Clear();
                    txt_Eghdam.Clear();
                }
                else
                    MessageBox.Show("داده های این ماه قبلا وارد شده است", "رکورد تکراری", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
        }
        private void buttonX3_Click(object sender, EventArgs e)
        {
            if (txt_month.Text == "")
                MessageBox.Show("هیچ  ماهی انتخاب نشده است", "خطای ثبت", MessageBoxButtons.OK, MessageBoxIcon.Information);
            else
            {
                if (con.Back_Query("select offset from info_Iso where month_='" + txt_month.Text + "' and des='" + lbl_Des.Text + "'") == "error")
                    MessageBox.Show("رکوردی جهت بروز رسانی وجود ندارد", "خطای ثبت", MessageBoxButtons.OK, MessageBoxIcon.Information);
                else
                {

                    if (MessageBox.Show("با بروز رسانی اطلاعات قبلی از بین می رود آیا برور رسانی انجام شود؟", "بروز رسانی رکورد", MessageBoxButtons.YesNo, MessageBoxIcon.Information) == DialogResult.Yes)
                    {
                        {
                            con.Back_Query("delete from  info_Iso where month_='" + txt_month.Text + "' and des='" + lbl_Des.Text + "'");
                            con.ExecuteNonQuery("insert into info_Iso values('" + txt_date.Text + "','" + desiner.Text + "','" + txt_month.Text + "','" + lbl_Des.Text + "','" + kryptonDataGridView1[0, 0].Value.ToString() + "','" + kryptonDataGridView1[1, 0].Value.ToString() + "','" + kryptonDataGridView1[2, 0].Value.ToString() + "','" + kryptonDataGridView1[3, 0].Value.ToString() + "','" + kryptonDataGridView1[4, 0].Value.ToString() + "','" + txt_Eghdam.Text + "','" + txt_Analiz.Text + "')");
                            kryptonDataGridView1[0, 0].Value = ""; kryptonDataGridView1[1, 0].Value = "";
                            kryptonDataGridView1[2, 0].Value = ""; kryptonDataGridView1[3, 0].Value = ""; kryptonDataGridView1[4, 0].Value = "";
                            txt_Analiz.Clear();
                            txt_Eghdam.Clear();
                        }

                    }
                }
            }
        }
        private void buttonX4_Click(object sender, EventArgs e)
        {
            if (txt_month.Text == "")
                MessageBox.Show("هیچ  ماهی انتخاب نشده است", "خطای ثبت", MessageBoxButtons.OK, MessageBoxIcon.Information);
            else
            {
                if (con.Back_Query("select offset from info_Iso where month_='" + txt_month.Text + "' and des='" + lbl_Des.Text + "'") == "error")
                    MessageBox.Show("رکوردی جهت بروز رسانی وجود ندارد", "خطای ثبت", MessageBoxButtons.OK, MessageBoxIcon.Information);
                else
                {

                    if (MessageBox.Show("آیا رکورد حذف گردد؟", "بروز رسانی رکورد", MessageBoxButtons.YesNo, MessageBoxIcon.Information) == DialogResult.Yes)
                    {
                        {
                            con.Back_Query("delete from  info_Iso where month_='" + txt_month.Text + "' and des='" + lbl_Des.Text + "'");
                            kryptonDataGridView1[0, 0].Value = ""; kryptonDataGridView1[1, 0].Value = "";
                            kryptonDataGridView1[2, 0].Value = ""; kryptonDataGridView1[3, 0].Value = ""; kryptonDataGridView1[4, 0].Value = "";
                            txt_Analiz.Clear();
                            txt_Eghdam.Clear();
                        }

                    }
                }
            }
        }
        private void txt_month_SelectedIndexChanged(object sender, EventArgs e)
        {
            con.View("SELECT Date_ as[تاریخ تهیه], Provider as[تهیه کننده], Month_ as[ماه],Des as[شرح شاخص],point as[مقدارهدف],tah as[میزان تحقق], offset as[انحراف], eghdam as[اقدامات انجام شده],analiz as[تحلیل] FROM Info_ISO where month_='"+txt_month.Text +"'", DataGridEXPORT);

        }
        private void buttonX5_Click(object sender, EventArgs e)
        {
            SaveFileDialog sfdExportToxcel = new SaveFileDialog();
            Tools.ExportToExcel.ExportToExcel exp = new Tools.ExportToExcel.ExportToExcel();
            sfdExportToxcel.FileName = "ISO_Report.xls";
            sfdExportToxcel.Filter = "Archivos Excel (*.xls)|*.xls|Todos los Archivos (*.*)|*.*";
            sfdExportToxcel.FilterIndex = 1;
            sfdExportToxcel.RestoreDirectory = true;

            if (sfdExportToxcel.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                string path = sfdExportToxcel.FileName;
                exp.dataGridView2Excel(this.DataGridEXPORT, path, txt_month.Text);
            } 
        }

    }
}
          


