﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Personal
{
    public partial class frm_Price_Karaneh : Form
    {
        ConnectionClass con = new ConnectionClass();
        int counter = 0;
        double Count_Personal = 0;
        double Saraneh = 0;
        double Mini_saraneh;
        string semat;
        public frm_Price_Karaneh(string Per_No)
        {
            InitializeComponent();
            lbl_per.Text = Per_No;
            lbl_area.Text = con.Back_Query("select area from info where per='" + Per_No + "'");
            lbl_family.Text = con.Back_Query("select fname+' '+lname from info where per='" + Per_No + "'");
            lbl_semat.Text = con.Back_Query("select semat from info where per='" + Per_No + "'");
            semat = con.Back_Query("select semat from info where per='" + lbl_per.Text + "'");
        }
        private void frm_Price_Karaneh_Load(object sender, EventArgs e)
        {
            Date_ dt = new Date_();
            txt_date.Text = dt.Now();
            txt_month.Items.Add("فروردین"); txt_month.Items.Add("اردیبهشت");
            txt_month.Items.Add("خرداد"); txt_month.Items.Add("تیر");
            txt_month.Items.Add("مرداد"); txt_month.Items.Add("شهریور");
            txt_month.Items.Add("مهر"); txt_month.Items.Add("آبان");
            txt_month.Items.Add("آذر"); txt_month.Items.Add("دی");
            txt_month.Items.Add("بهمن"); txt_month.Items.Add("اسفند");
            if (lbl_semat.Text == "مدیر") Manager();
            if (lbl_semat.Text == "رئیس") Boss();

        }
        private void Manager()
        {
            con.View("SELECT DISTINCT area AS ناحیه, MIN(per) AS [قسمت], COUNT(per) AS [تعدادپرسنل],MAX(per) AS [سرانه],min(per) as[سمت شغلی]  FROM info where semat='" + "کارشناس" + "' or semat='" + "سرشيفت" + "' or semat='" + "اپراتور" + "' GROUP BY area ", dbGrid);
            for (counter = 0; counter < dbGrid.Rows.Count - 1; counter++)
            {//خالی نمودن مقادیر سرانه و قسمت
                dbGrid[1, counter].Value = "0";
                dbGrid[3, counter].Value = "0";
                dbGrid[4, counter].Value = "0";
            }
        }
        private void Boss()
        {
            txt_saraneh.Text = (double.Parse(txt_price.Text) / double.Parse(con.Back_Query("select count(*) from info where area='" + lbl_area.Text + "' and semat<>'" + "رئيس" + "'"))).ToString();
            txt_price.Enabled = false;
            con.View("SELECT  DISTINCT sum(per) as[ناحیه],part as[قسمت], COUNT(per) AS [تعدادپرسنل],MAX(per) AS [سرانه],max(fname) as[سمت شغلی] FROM info where ( semat='" + "سرشيفت" + "' or semat='" + "اپراتور" + "') and area='" + lbl_area.Text + "' GROUP BY part ", dbGrid);
            dbGrid[1, dbGrid.Rows.Count - 1].Value = "کارشناس";
            dbGrid[2, dbGrid.Rows.Count - 1].Value = con.Back_Query("select count(*) from info where area='"+lbl_area.Text+"' and semat='"+"کارشناس"+"'").ToString();
            dbGrid[3, dbGrid.Rows.Count - 1].Value = "0";
            dbGrid[4, dbGrid.Rows.Count - 1].Value = "کارشناس";
            dbGrid[0, dbGrid.Rows.Count - 1].Value = lbl_area.Text ;

            for (counter = 0; counter < dbGrid.Rows.Count; counter++)
            {//خالی نمودن مقادیر سرانه و قسمت
                dbGrid[0, counter].Value = lbl_area.Text ;
                dbGrid[3, counter].Value =((double.Parse( txt_saraneh.Text))*(double.Parse(dbGrid[2, counter].Value.ToString()))).ToString();
                dbGrid[4, counter].Value = "اپراتور/سرشیفت";
            } dbGrid[4, dbGrid.Rows.Count-1].Value = "کارشناس";
          }
        private void buttonX1_Click(object sender, EventArgs e)
        {

            if (semat == "مدیر") Manager();
            if (semat == "رئيس") Boss();
            if (txt_price.Text != "")
            {//جهت بدست آوردن ضریب کارشناس
                double Multi_Karshenai=double.Parse(con.Back_Query("select val from semat_multi where semat='"+"کارشناس"+"'"));
                if (lbl_semat.Text == "مدیر")
                {//جهت بدست آوردن مجموع پرسنل
                    Count_Personal = double.Parse(con.Back_Query("select count(per) from info where (semat='" + "کارشناس" + "' or semat='" + "سرشیفت" + "' or semat='" + "اپراتور" + "')"));
                    //محاسبه سرانه
                    Saraneh = double.Parse(txt_price.Text) / Count_Personal;
                    for (counter = 0; counter < dbGrid.Rows.Count - 1; counter++)
                        //محاسبه سرانه هر ناحیه
                        dbGrid[3, counter].Value = (Math.Round(double.Parse(dbGrid[2, counter].Value.ToString()) * Saraneh)).ToString();
                    Dbgrid_Sum(0);
                }
                //=========================================
                if (lbl_semat.Text == "رئیس")
                {
                    Count_Personal =double.Parse( con.Back_Query("select count(*) from info where (semat='" + "کارشناس" + "' or semat='" + "سرشیفت" + "' or semat='" + "اپراتور" + "') and area='"+lbl_area.Text+"' "));
                    dbGrid[3, dbGrid.Rows.Count - 1].Value = Math.Round(double.Parse(txt_price.Text)/Count_Personal * double.Parse(dbGrid[2, dbGrid.Rows.Count - 1].Value.ToString())*Multi_Karshenai ).ToString();
                    Mini_saraneh = (double.Parse(txt_price.Text) - double.Parse(dbGrid[3, dbGrid.Rows.Count - 1].Value.ToString())) / double.Parse(con.Back_Query("select count(*) from info where (semat='" + "سرشیفت" + "' or semat='" + "اپراتور" + "') and area='" + lbl_area.Text + "' ")); 
                      for (counter = 0; counter < dbGrid.Rows.Count - 1; counter++)
                         dbGrid[3, counter].Value=Math.Round( double.Parse(dbGrid[2, counter].Value.ToString())*Mini_saraneh).ToString();
                      Dbgrid_Sum(1);
                }

            }
            else
            {
                MessageBox.Show("مقداری برای تخصیص بودجه درج نشده است", "عدم تخصصیص بودجه", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }

        }
        private void Dbgrid_Sum(int x)
        {
            double sum = 0;
            for (counter = 0; counter < dbGrid.Rows.Count - 1; counter++)
                //محاسبه سرانه هر ناحیه
                sum += double.Parse(dbGrid[3, counter].Value.ToString());
            if (x==1) sum+=double.Parse(dbGrid[3, dbGrid.Rows.Count - 1].Value.ToString());
            MessageBox.Show("بودجه تخصیص داده شده",sum.ToString());
        }
        private void buttonX2_Click(object sender, EventArgs e)
        {
            if ((txt_month.Text == "") || (txt_date.Text == ""))
                MessageBox.Show("فیلد خالی مجاز نمی باشد", "عدم تخصصیص بودجه", MessageBoxButtons.OK, MessageBoxIcon.Information);
            else
            {
                if (con.Back_Query("select provider from karaneh_unit where provider='" + lbl_family.Text + "' and month_='" + txt_month.Text + "'") != "error")
                {

                        if (MessageBox.Show("تخصیص بودجه در ماه فوق انجام گردیده است آیا اطلاعات جدید جایگزین شود؟", "عدم تخصصیص بودجه", MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.Yes)
                        {
                            con.ExecuteNonQuery("delete from karaneh_unit where month_='"+txt_month.Text+"' and  provider='"+lbl_family.Text+"'");
                            for (counter = 0; counter < dbGrid.Rows.Count; counter++)
                            {
                                con.Back_Query("insert into karaneh_unit values('" + lbl_family.Text + "'," +
                                        "'" + dbGrid[0, counter].Value.ToString() + "'," +
                                        "'" + dbGrid[1, counter].Value.ToString() + "'," +
                                        "'" + dbGrid[2, counter].Value.ToString() + "'," +
                                        "'" + dbGrid[3, counter].Value.ToString() + "'," +
                                        "'" + dbGrid[4, counter].Value.ToString() + "'," +
                                        "'" + txt_date.Text + "'," +
                                        "'" + txt_month.Text + "')");
                            }
                            MessageBox.Show("عملیات تخصیص بودجه با موفقیت انجام گردید", "عدم تخصصیص بودجه", MessageBoxButtons.OK, MessageBoxIcon.Information);

                        }

                }
                else
                {
                    for (counter = 0; counter < dbGrid.Rows.Count ; counter++)
                    {
                        con.Back_Query("insert into karaneh_unit values('" + lbl_family.Text + "'," +
                                "'" + dbGrid[0, counter].Value.ToString() + "'," +
                                "'" + dbGrid[1, counter].Value.ToString() + "'," +
                                "'" + dbGrid[2, counter].Value.ToString() + "'," +
                                "'" + dbGrid[3, counter].Value.ToString() + "'," +
                                "'" + dbGrid[4, counter].Value.ToString() + "'," +
                                "'" + txt_date.Text + "'," +
                                "'" + txt_month.Text + "')");
                    }
                    MessageBox.Show("عملیات تخصیص بودجه با موفقیت انجام گردید", "عدم تخصصیص بودجه", MessageBoxButtons.OK, MessageBoxIcon.Information);

                }
                   
            }
        }
        private void buttonX3_Click(object sender, EventArgs e)
        {
            if (txt_month.Text == "")
                MessageBox.Show("ماه مورد نظر را انتخاب نمائید", "گزارش تخصصیص بودجه", MessageBoxButtons.OK, MessageBoxIcon.Information);

            else
                con.View("select provider as [تهیه کننده] ,area as [ناحیه],part as[قسمت],per as[تعداد پرسنل] ,saraneh as[سرانه],semat as[سمت شغلی],date_ as[تاریخ],month_ as[ماه] from karaneh_unit where provider='" + lbl_family.Text + "' and month_='" + txt_month.Text + "'", dbGrid);
        }
        private void buttonX4_Click(object sender, EventArgs e)
        {
            System.Diagnostics.Process.Start("calc.exe");
        }
        private void txt_month_TextChanged(object sender, EventArgs e)
        {
            if (semat == "رئيس")
            {

                if (con.Back_Query("select saraneh from karaneh_unit where area='" + lbl_area.Text + "' and month_='" + txt_month.Text + "'") == " ")
                    MessageBox.Show("برای ماه فوق بودجه ای تخصیص داده نشده است", "تخصیص سرانه", MessageBoxButtons.OK, MessageBoxIcon.Information);
                else
                    txt_price.Text = con.Back_Query("select saraneh from karaneh_unit where area='" + lbl_area.Text + "' and month_='" + txt_month.Text + "'");
            }
        }


    }
}
