﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Tools;
namespace Personal
{
    public partial class frm_PersonalHozor : Form
    {
        ConnectionClass con = new ConnectionClass();
        Date_ dt = new Date_();
        string curentuser;
        public frm_PersonalHozor(string user)
        {
            InitializeComponent();
            curentuser = user;
            txt_Date.Text = dt.Now();
            txt_register.Text=con.Back_Query("select fname+' '+lname as family from info where per='"+user+"'");
            txtcount.Text ="تعداد پرسنل حاضر"+ kryptonDataGridView1.Rows.Count.ToString();
        }
        private void frm_PersonalHozor_Load(object sender, EventArgs e)
        {
            con.View("SELECT  Hozor.id AS ردیف, info.fname + ' ' + info.lname AS [نام و نام خانوادگی], Hozor.register AS [ثبت کننده], Hozor.date_ AS تاریخ, Hozor.shift AS شیفت, info.part AS قسمت, info.area as[ناحیه] FROM     info INNER JOIN  Hozor ON info.per = Hozor.per where date_='"+txt_Date.Text+"'", kryptonDataGridView1);
            txtcount.Text = "پرسنل حاضر" + kryptonDataGridView1.Rows.Count.ToString();
        }
        private void kryptonButton1_Click(object sender, EventArgs e)
        {
            Boolean check;
            check = true;
            string msg = ""; ;
            string semat=con.Back_Query("select semat from info where per='"+curentuser+"'");

            if (txtfamily.Text == "0") {check = false; msg = "شماره پرسنلی معتبر نمی باشد";}
            if (semat != "سرشيفت") { check = false; msg = "از لحاظ سازمانی شما مجاز به ثبت نمی باشید"; }
            if (con.Back_Query("select part from info where per='" + txtper.Text + "'") != con.Back_Query("select part from info where per='" + curentuser + "'")) { check = false; msg = "شما مجاز به ثبت برای این پرسنل از لحاظ سازمانی نمی باشید"; }
            if (txtshift.Text == "") { check = false; msg = "شیفت حضور انتخاب نشده است"; }
            if (con.Back_Query("select id from hozor where per='" + txtper.Text + "' and register='" + txt_register.Text + "' and date_='" + txt_Date.Text + "'") != "0") { check = false; msg = "رکود قبلا ثبت شده است"; }
            if(con.Back_Query("select username from login where per='"+curentuser+"'")=="Admin")check=true;
            if (check == true)
            {
                con.ExecuteNonQuery("insert into hozor values('" + txtper.Text + "','" + txt_register.Text + "','" + txt_Date.Text + "','" + txtshift.Text + "')");
                con.View("SELECT  Hozor.id AS ردیف, info.fname + ' ' + info.lname AS [نام و نام خانوادگی], Hozor.register AS [ثبت کننده], Hozor.date_ AS تاریخ, Hozor.shift AS شیفت, info.part AS قسمت, info.area as[ناحیه] FROM     info INNER JOIN  Hozor ON info.per = Hozor.per where date_='" + txt_Date.Text + "'", kryptonDataGridView1);
                txtcount.Text = "پرسنل حاضر" + kryptonDataGridView1.Rows.Count.ToString();
                txtper.Text = "";
                txtper.Focus();
            }
            else
                MessageBox.Show(msg, "خطای ثبت", MessageBoxButtons.OK, MessageBoxIcon.Information);
        }
        private void txtper_TextChanged(object sender, EventArgs e)
        {
            if (txtper.Text.Length == 6)
                txtfamily.Text = con.Back_Query("select fname+' '+lname as family from info where per='" + txtper.Text + "'");

        }

        private void ارسالبهاکسلToolStripMenuItem_Click(object sender, EventArgs e)
        {
            SaveFileDialog sfdExportToxcel = new SaveFileDialog();
            Tools.ExportToExcel.ExportToExcel exp = new Tools.ExportToExcel.ExportToExcel();
            sfdExportToxcel.FileName = "گزارش حضور پرسنل.xls";
            sfdExportToxcel.Filter = "Archivos Excel (*.xls)|*.xls|Todos los Archivos (*.*)|*.*";
            sfdExportToxcel.FilterIndex = 1;
            sfdExportToxcel.RestoreDirectory = true;

            if (sfdExportToxcel.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                string path = sfdExportToxcel.FileName;
                exp.dataGridView2Excel(this.kryptonDataGridView1, path, "NameSheet");
            }
           
        }

        private void چاپToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Print prt = new Print();
            prt.PrintDataGrid(kryptonDataGridView1, "گزارش حضور پرسنل", "");
        }


        private void toolStripTextBox1_TextChanged(object sender, EventArgs e)
        {
            if (toolStripTextBox1.Text.Length == 10)
            {
                con.View("SELECT  Hozor.id AS ردیف, info.fname + ' ' + info.lname AS [نام و نام خانوادگی], Hozor.register AS [ثبت کننده], Hozor.date_ AS تاریخ, Hozor.shift AS شیفت, info.part AS قسمت, info.area as[ناحیه] FROM     info INNER JOIN  Hozor ON info.per = Hozor.per where date_='" + toolStripTextBox1.Text + "' ", kryptonDataGridView1);
                txtcount.Text = "پرسنل حاضر" + kryptonDataGridView1.Rows.Count.ToString();
            }
        }

        private void toolStripTextBox2_TextChanged(object sender, EventArgs e)
        {
            if (toolStripTextBox2.Text.Length == 6)
            {
                con.View("SELECT  Hozor.id AS ردیف, info.fname + ' ' + info.lname AS [نام و نام خانوادگی], Hozor.register AS [ثبت کننده], Hozor.date_ AS تاریخ, Hozor.shift AS شیفت, info.part AS قسمت, info.area as[ناحیه] FROM     info INNER JOIN  Hozor ON info.per = Hozor.per where date_='" + txt_Date.Text + "' and hozor.per='" + toolStripTextBox2.Text + "'", kryptonDataGridView1);
                txtcount.Text = "پرسنل حاضر" + kryptonDataGridView1.Rows.Count.ToString();
            }
        }




    }
}
