﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using mgh;
using System.Diagnostics;
using System.Text.RegularExpressions;
using Tools.ExportToExcel;
namespace Personal
{
    public partial class frm_main : Form
    {
        ConnectionClass con = new ConnectionClass();
        string Curent_User = "";
        public string Kars_Query;
        public frm_main(string user)
        {
            InitializeComponent();
            Curent_User = user; 
            lbl_pm.Text = con.Back_Query("SELECT * FROM PM");
            lbl_User.Text = con.Back_Query("select family from login where per='" + user + "'");
        }
        private void Form1_Load(object sender, EventArgs e)
        {
     
            this.Text = con.Name_Company;
            Disbled_Item();
            curent_timer.Text = System.DateTime.Now.Hour.ToString() + ":" + System.DateTime.Now.Minute.ToString() + ":" + System.DateTime.Now.Second.ToString();
            Calander();
               if (System.IO.File.Exists(con.File_Dir) == true)
                {
                    try
                    {
                        FileStream fs = new FileStream(con.File_Dir, FileMode.Open, FileAccess.Read, FileShare.Read);
                        StreamReader sw = new StreamReader(fs);
                        string x = sw.ReadLine();
                        sw.Close();
                        this.BackgroundImage = System.Drawing.Image.FromFile(x);
                    }
                    catch( Exception)
                    {
                       this.BackgroundImage = System.Drawing.Image.FromFile(con.Pic_Dir );
                    }
                }
                else
                {
                    this.BackgroundImage = System.Drawing.Image.FromFile(con.Pic_Dir);
                }


               Permission(con.Back_Query("select permission from login where FAMILY=N'" + lbl_User.Text + "'"));


        }
        private void notifyIcon1_MouseMove(object sender, MouseEventArgs e)
        {
            notifyIcon1.Text = "شرکت صنایع هفت الماس";
        }
        private void button5_Click(object sender, EventArgs e)
        {
            this.Visible = false;
            notifyIcon1.Visible = true;
        }
        private void Permission(string AccessLevel)
        {
            DataGridView DVG = new DataGridView();
            this.Controls.Add(DVG);
            DVG.Visible = false;

            if (AccessLevel == "1") con.View("select level1 from permission", DVG);
            if (AccessLevel == "2") con.View("select level2 from permission", DVG);
            if (AccessLevel == "3") con.View("select level3 from permission", DVG);
            if (AccessLevel == "4") con.View("select level4 from permission", DVG);
            if (AccessLevel == "5") con.View("select level5 from permission", DVG);
            if (AccessLevel == "6") con.View("select level6 from permission", DVG);
            if (DVG[0,0].Value.ToString() == "Yes") Defin_Personal.Enabled = true;
            if (DVG[0, 1].Value.ToString() == "Yes") Defin_Unit.Enabled = true ;
            if (DVG[0, 2].Value.ToString() == "Yes") Defin_User.Enabled = true ;
            if (DVG[0, 3].Value.ToString() == "Yes") Morkhasi.Enabled=true ;
            if (DVG[0, 4].Value.ToString() == "Yes") EzafeKar.Enabled = true;
            if (DVG[0, 5].Value.ToString() == "Yes") Shift_Change.Enabled = true;
            if (DVG[0, 6].Value.ToString() == "Yes") Report_manager.Enabled = true;
            if (DVG[0, 7].Value.ToString() == "Yes") Report_Personal.Enabled = true;
            if (DVG[0, 8].Value.ToString() == "Yes") Recid_Buy.Enabled = true;
            if (DVG[0, 9].Value.ToString() == "Yes") Center_Tab.Enabled = true;
            if (DVG[0, 10].Value.ToString() == "Yes") Lib_Manager.Enabled = true;
            if (DVG[0, 11].Value.ToString() == "Yes") Lib_Cab.Enabled = true;
            if (DVG[0, 12].Value.ToString() == "Yes") Manger_Seting_aqord.Enabled = true;
            if (DVG[0, 13].Value.ToString() == "Yes") Unit_Setting_Aqord.Enabled = true;
            if (DVG[0, 14].Value.ToString() == "Yes") Daily_report_Aqord.Enabled = true;
            if (DVG[0, 15].Value.ToString() == "Yes") Monthly_Report_Aqord.Enabled = true;
            if (DVG[0, 16].Value.ToString() == "Yes") Price_Parcer_Aqord.Enabled = true;
            if (DVG[0, 17].Value.ToString() == "Yes") Report_Aqord.Enabled = true;
            if (DVG[0, 18].Value.ToString() == "Yes") Reverse_lineReport.Enabled = true;
            if (DVG[0, 19].Value.ToString() == "Yes") Anneali_LineReport.Enabled = true;
            if (DVG[0, 20].Value.ToString() == "Yes") Defin_Iso.Enabled = true;
            if (DVG[0, 21].Value.ToString() == "Yes") DataIntry_Iso.Enabled = true;
            if (DVG[0, 22].Value.ToString() == "Yes") Report_Iso.Enabled = true;
            if (DVG[0, 23].Value.ToString() == "Yes") Email.Enabled = true;
            if (DVG[0, 24].Value.ToString() == "Yes") Bulletin.Enabled = true;
            if (DVG[0, 25].Value.ToString() == "Yes") ChangePassword.Enabled = true;
            if (DVG[0, 26].Value.ToString() == "Yes") ChangeWallpaper.Enabled = true;
            if (DVG[0, 27].Value.ToString() == "Yes") Indicator.Enabled = true;
            if (DVG[0, 28].Value.ToString() == "Yes") Message_All.Enabled = true;
            if (DVG[0, 29].Value.ToString() == "Yes") IO_User.Enabled = true;
            if (DVG[0, 30].Value.ToString() == "Yes") DataBakup.Enabled = true;
            if (DVG[0, 31].Value.ToString() == "Yes") Program_Setting.Enabled = true;
            if (DVG[0, 32].Value.ToString() == "Yes") Defin_Permission.Enabled = true;
            if (Defin_Iso.Enabled == true) office.Enabled = true;
          
        }
        private void ChangeWalpaper()
        {
            OpenFileDialog openFile = new OpenFileDialog();
            openFile.DefaultExt = "Back";
            openFile.Filter = "Image File (*.jpg)|*.jpg";
            openFile.ShowDialog();
            if (openFile.FileName != "")
            {
               System.IO.File.Delete(con.File_Dir);
               this.BackgroundImage = System.Drawing.Image.FromFile(openFile.FileName);
                FileStream fs = new FileStream(con.File_Dir, FileMode.Append, FileAccess.Write, FileShare.Read);
                StreamWriter sw = new StreamWriter(fs);
                sw.Write(openFile.FileName.ToString());
                sw.Close();
            }
        }
        private void Calander()
        {
            Date_ dt = new Date_();
            string btn_today;
            string Today = dt.now_NoSlash();
            string Week = dt.Curent_Day_Week();
            if (con.Back_Query("select val from calander where jomeh='" + Today + "'") == "1") btn_today= "جمعه کاری";
            else
                if (con.Back_Query("select val from calander where taofogh='" + Today + "'") == "1") btn_today= "تعطیلی توافقی";
                else
                    if (con.Back_Query("select val from calander where change='" + Today + "'") == "1") btn_today= "تعطیلی جایگزین";
                    else
                        if (con.Back_Query("select val from calander where rasmi='" + Today + "'") == "1") btn_today= "تعطیلی رسمی";
                        else
                            btn_today= "کارکرد عادی";

            lbl_curentday.Text = Week + ":" + btn_today;
            lbl_date.Text = dt.Now(); 

        }
        private void timer_mail_Tick(object sender, EventArgs e)
        {
            curent_timer.Text = System.DateTime.Now.Hour.ToString() + ":" + System.DateTime.Now.Minute.ToString() + ":" + System.DateTime.Now.Second.ToString();
            if (con.Back_Query("select id from email where status='" + "unread" + "' and resiver='" + lbl_User.Text + "'") != "error")
            {
                errorProvider1.SetError(label2, "You Have New Mail");
          
            }
            else
            {
           
                errorProvider1.Clear();
            }

        }
        private void Update_Software()
        {



        }
        private void btn_changewalpaper_Click(object sender, EventArgs e)
        {
            ChangeWalpaper();
        }
        private void مرخصیToolStripMenuItem_Click(object sender, EventArgs e)
        {
            mor frm = new mor(); frm.ShowDialog();
        }
        private void اضافهکارToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Frm_ez frm = new Frm_ez(); frm.ShowDialog();
        }
        private void تعویضشیفتToolStripMenuItem_Click(object sender, EventArgs e)
        {
            shift frm = new shift(); frm.ShowDialog(); 
        }
        private void معرفیپرسنلToolStripMenuItem_Click(object sender, EventArgs e)
        {
            pERSONAL frm = new pERSONAL(); frm.ShowDialog();
        }
        private void معرفیواحدهاToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frm_unit frm = new frm_unit(); frm.ShowDialog();
        }
        private void گزارشمدیریتToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frm_Report frm = new frm_Report(); frm.ShowDialog();
        }

        private void مشخصاتپرسنلToolStripMenuItem_Click(object sender, EventArgs e)
        {
           frm_per  frm = new frm_per(); frm.ShowDialog();
        }

        private void صدوردرخواستخریدToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frm_Buy frm = new frm_Buy(); frm.ShowDialog(); 
        }

        private void مراکزهزینهToolStripMenuItem_Click(object sender, EventArgs e)
        {
            inv frm = new inv(); frm.ShowDialog();
        }

        private void مدیریتکتابهاToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frm_Mnager_lib frm = new frm_Mnager_lib(); frm.ShowDialog();
        }

        private void قفسهکتابخانهToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frm_lib frm = new frm_lib(); frm.ShowDialog();
        }

        private void تنظیماتمدیریتToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frm_Grant frm = new frm_Grant(); frm.ShowDialog();
        }

        private void تنظیماترئیسواحدToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frm_Multi_Group frm = new frm_Multi_Group(Curent_User); frm.ShowDialog();
        }

        private void امتیازروزانهToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frm_randeman frm = new frm_randeman(Curent_User); frm.ShowDialog();
        }

        private void توزیToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frm_Price_Karaneh frm = new frm_Price_Karaneh(Curent_User); frm.ShowDialog();
        }

        private void گزارشنهاییToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frm_final_Karaneh frm = new frm_final_Karaneh(Curent_User);
        }

        private void خطریورسToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frm_reverse frm = new frm_reverse(Curent_User); frm.ShowDialog();
        }

        private void خطآنیلToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frm_Anneal frm = new frm_Anneal();
            frm.ShowDialog();   
        }

        private void تعریفاهدافToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Frm_Point_Iso frm = new Frm_Point_Iso(); frm.ShowDialog();
        }

        private void وروداطلاعاتToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frm_DatEntry_ISO frm = new frm_DatEntry_ISO(Curent_User); frm.ShowDialog();
        }

        private void گزارشToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frm_Report frm = new frm_Report(); frm.ShowDialog(); 
        }

        private void صندوقپستیمنToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frm_email frm = new frm_email(Curent_User); frm.ShowDialog();
        }

        private void ورودوخروجکاربرانToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frm_IO frm = new frm_IO(); frm.ShowDialog();
        }

        private void تابلویاعلاناتToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frm_help frm = new frm_help(con.Agahi_Dir); frm.ShowDialog();

        }

        private void تغییررمزعبورToolStripMenuItem1_Click(object sender, EventArgs e)
        {
            ChangePassword frm = new ChangePassword(lbl_User.Text ); frm.ShowDialog();
        }

        private void دفترانToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frm_Later frm = new frm_Later(); frm.ShowDialog();  
        }

        private void پیامفراگیرToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frm_PM frm = new frm_PM(); frm.ShowDialog();
        }

        private void تهیهوبروزرسانینسخهپشتیبانToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frm_Backup frm = new frm_Backup(); frm.ShowDialog();
        }

        private void پنهاننمودنکنارساعتToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.Visible = false;
            notifyIcon1.Visible = true;
           
        }

        private void تغییرکاربرToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.Hide();
            Start frm = new Start(); frm.ShowDialog();
        }

        private void خروجازبرنامهToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }

        private void معرفیکاربرانToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frm_UserSetting frm = new frm_UserSetting(); frm.ShowDialog();
        }

        private void frm_main_Deactivate(object sender, EventArgs e)
        {
            
        }

        private void تنظیماتبرنامهToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frm_ProgSetting frm = new frm_ProgSetting();
            frm.ShowDialog();
        }

        private void Defin_Permission_Click(object sender, EventArgs e)
        {
            Frm_Permission frm = new Frm_Permission();
            frm.ShowDialog();
        }
        private void Disbled_Item()
        {
            Defin_Personal.Enabled = false;
            Defin_Unit.Enabled = false;
            Defin_User.Enabled = false;
            Morkhasi.Enabled = false;
            EzafeKar.Enabled = false;
            Shift_Change.Enabled = false;
            Report_manager.Enabled = false; ;
            Report_Personal.Enabled = false;
            Recid_Buy.Enabled = false;
             Center_Tab.Enabled = false;
             Lib_Manager.Enabled = false;
             Lib_Cab.Enabled = false;
             Manger_Seting_aqord.Enabled = false;
             Unit_Setting_Aqord.Enabled = false;
             Daily_report_Aqord.Enabled = false;
             Monthly_Report_Aqord.Enabled = false;
             Price_Parcer_Aqord.Enabled = false;
             Report_Aqord.Enabled = false;
             Reverse_lineReport.Enabled = false;
             Anneali_LineReport.Enabled = false;
             Defin_Iso.Enabled = false;
             DataIntry_Iso.Enabled = false;
             Report_Iso.Enabled = false;
             Email.Enabled = false;
             Bulletin.Enabled = false;
             ChangePassword.Enabled = false;
             ChangeWallpaper.Enabled = false;
             Indicator.Enabled = false;
             Message_All.Enabled = false;
             IO_User.Enabled = false;
             DataBakup.Enabled = false;
             Program_Setting.Enabled = false;
             Defin_Permission.Enabled = false;
        }

        private void txt_per_TextChanged(object sender, EventArgs e)
        {

        }

        private void تهیهگزارشToolStripMenuItem_Click(object sender, EventArgs e)
        {
             if (Type_rpt.Text == "مرخصی") con.View("select date_ as[تاریخ مرخصی],number as[مقدار مرخصی] from mor where per='" + txt_per.Text + "' and(date_>'" + txt_date1.Text + "' and date_<'" + txt_date2.Text + "')", kryptonDataGridView1);
            if (Type_rpt.Text == "اضافه کاری") con.View("select date_ as[تاریخ اضافه کاری],number as[مقداراضافه کاری] from ez where per='"+txt_per.Text +"' and(date_>'" + txt_date1.Text + "' and date_<'" + txt_date2.Text + "')", kryptonDataGridView1);
            if (Type_rpt.Text == "تعویض شیفت") con.View("select date_ as[تاریخ تعویض شیفت],per1 as[درخواست دهنده],shift1 as[شیفت ],per2 as[متعهد],shift2 as[شیفت متعهد] from shift where (date_>'" + txt_date1.Text + "' and date_<'" + txt_date2.Text + "') and(per1='"+txt_per.Text+"' or per2='"+txt_per.Text+"')", kryptonDataGridView1);
                kryptonDataGridView1.Visible=true;
        }

        private void خروجازگزارشToolStripMenuItem_Click(object sender, EventArgs e)
        {
            kryptonDataGridView1.Visible = false;
        }

        private void txt_per_Click(object sender, EventArgs e)
        {
            txt_per.Clear();
        }

        private void txt_date1_Click(object sender, EventArgs e)
        {
            txt_date1.Clear();
        }

        private void txt_date2_Click(object sender, EventArgs e)
        {
            txt_date2.Clear();
        }

        private void چاپگزارشToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Print prt = new Print();
            prt.PrintDataGrid(kryptonDataGridView1,"گزارش پرسنلی",con.Name_Company);
        }

        private void ارسالبهاکسلToolStripMenuItem_Click(object sender, EventArgs e)
        {
            SaveFileDialog sfd = new SaveFileDialog();
            sfd.InitialDirectory = Environment.SpecialFolder.Desktop.ToString();
            sfd.Filter = "Excell File files (*.xls)|*.XLS";
            sfd.RestoreDirectory = true;
            sfd.ShowDialog();
           string  path = sfd.FileName.ToString();
            ExportToExcel ex = new ExportToExcel();
            ex.dataGridView2Excel(kryptonDataGridView1, path, "Report");
        }

        private void contextMenuStrip2_Opening(object sender, CancelEventArgs e)
        {

        }

        private void خروجازبرنامهToolStripMenuItem_Click_1(object sender, EventArgs e)
        {
            notifyIcon1.Visible = false;
            Application.Exit();
        }

        private void نملشبرنامهToolStripMenuItem_Click(object sender, EventArgs e)
        {
            notifyIcon1.Visible = false;
            this.Visible = true;
        }

        private void لوازمالتحریرToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frm_office frm = new frm_office();
            frm.ShowDialog();
        }

        private void دربارهماToolStripMenuItem_Click(object sender, EventArgs e)
        {
            AboutBox1 frm = new AboutBox1();
            frm.ShowDialog();
        }

   }
}
