﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using mgh;
namespace Personal
{
    public partial class mor : Form
    {
        ConnectionClass con = new ConnectionClass();
        Date_ dt = new Date_();
        public mor()
        {
            InitializeComponent();
        }
        private void mor_Load(object sender, EventArgs e)
        {
            restart();
        }
        private void restart()
        {
            txt_per.Clear();
            txt_date.Text = dt.Year_ + dt.Month_;
            txt_per.Focus();
            con.View("select id as[ردیف],per as[شماره پرسنلی],date_ as[تاریخ],number as[مقدار],status as[وضعیت] from mor ", dataGridView1);
            

        }
        private void textBox1_TextChanged_1(object sender, EventArgs e)
        {
            if (Microsoft.VisualBasic.Strings.Len(txt_per.Text) == 6)
            {
                txt_date.Focus();
                fname.Text = con.Back_Query("select fname from info where per='" + txt_per.Text + "'");
                lname.Text = con.Back_Query("select lname from info where per='" + txt_per.Text + "'");
                con.View("select id as[ردیف],per as[شماره پرسنلی],date_ as[تاریخ],number as[مقدار],status as[وضعیت],mark as[توضیحات] from mor where Per ='" + txt_per.Text + "' and date_>'" + dt.Last_Month() + "'", dataGridView1);

            }
        }
        private void textBox2_TextChanged_1(object sender, EventArgs e)
        {
            if (Microsoft.VisualBasic.Strings.Len(txt_date.Text) == 10)
            {
                textBox3.Focus();
            }
        }
        private void button1_Click(object sender, EventArgs e)
        {
            con.ExecuteNonQuery("Update Mor set  per='" + txt_per.Text + "' and date_='" + txt_date.Text + "' and number='" + textBox3.Text + "' where id='" + row.Text + "'");
        }
        private void dataGridView1_CellClick(object sender, DataGridViewCellEventArgs e)
        {
           row.Text = dataGridView1[0, dataGridView1.CurrentRow.Index].Value.ToString();
           txt_per.Text = dataGridView1[1,dataGridView1.CurrentRow.Index ].Value.ToString();
           txt_date.Text = dataGridView1[2, dataGridView1.CurrentRow.Index].Value.ToString();
           textBox3.Text = dataGridView1[3, dataGridView1.CurrentRow.Index].Value.ToString();
        }
        private void textBox1_Leave(object sender, EventArgs e)
        {
            if (con.Back_Query("select fname from info where per='" + txt_per.Text + "'") == "0")
            {
                txt_per.Focus();
                ep.SetError(txt_per, "شماره پرسنلی معتبر نمی باشد");
            }
            else
            {
                ep.Clear();
            }
        }
        private void textBox2_Leave(object sender, EventArgs e)
        {
            if (FarsiDate.IsValidDate(txt_date.Text) == false)
            {
                txt_date.Clear();
                txt_date.Focus();
                ep.SetError(txt_date, "تاریخ معتبر نمی باشد");
            }
            if (FarsiDate.IsValidDate(txt_date.Text) == true)
            {
                ep.Clear();
            }
        }
        private Boolean check_blockEz()
        {
            if (con.Back_Query("select id from block_mor where per='" + txt_per.Text + "' and (date_1<='" + txt_date.Text + "' and date_2>= '" + txt_date.Text + "') ") == "0")
                return true ;
            else
                return
                    false ;
        }
        private void btn_Save_Click(object sender, EventArgs e)
        {
            int cnt = int.Parse(con.Back_Query("select max(id) from count"));
            if ((txt_per.Text == "") || (txt_date.Text == "") || (textBox3.Text == "")) MessageBox.Show("فیلد خالی مجاز نمی باشد");
            else
            {
                if (con.Back_Query("select per from info where per='" + txt_per.Text + "'") == "0") MessageBox.Show("شماره پرسنلی معتبر نمی باشد");
                else
                {
                    if (check_blockEz() == true)
                    {
                        if (con.Back_Query("select id from mor where per='" + txt_per.Text + "' and date_='" + txt_date.Text + "' and number='" + textBox3.Text + "'") !="0") MessageBox.Show("این رکورد قبلا ثبت شده است");
                        else
                        {
                            if (con.Back_Query("select per from ez where per='" + txt_per.Text + "' and date_='" + txt_date.Text + "' ") == "0")
                            {
                                txt_per.Focus();
                                con.Back_Query("insert into mor  values ('"+cnt+"','" + txt_per.Text + "','" + txt_date.Text + "','" + textBox3.Text + "','" + txt_status.Text + "','" + txt_mark.Text + "')");
                                txt_per.Clear();
                                txt_date.Clear();
                                txt_date.Text = dt.Year_ + dt.Month_;
                                Console.Beep();
                                con.View("select id as[ردیف],per as[شماره پرسنلی],date_ as[تاریخ],number as[مقدار],status as[وضعیت] from mor where Per like '" + txt_per.Text + "%'", dataGridView1);
                                row.Text =cnt.ToString();
                            }
                            else
                                FarsiMessagbox.Show("این کاربر در این روز مجوز مرخصی داشته و مجاز به اضافه کار نمی باشد", "خطای ثبت ", FMessageBoxButtons.Ok, FMessageBoxIcon.Warning);
                       
                       }
                    }
                    else
                        FarsiMessagbox.Show("پرسنل فوق بدلیل بلوکه بودن مرخصی مجاز به مرخصی نمی باشد", "بلوکه بودن مرخصی", FMessageBoxButtons.Ok, FMessageBoxIcon.Information);
                }
            }
        }
        private void btn_Del_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("آیا رکورد حذف شود", "حذف رکورد", MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.Yes)
            {
                con.Back_Query("delete from mor where per='" + txt_per.Text + "' and date_='" + txt_date.Text + "' and number='" + textBox3.Text + "'");
            }
        }
    }
}
