﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using dotnetCHARTING.WinForms;
using System.Runtime.InteropServices;
using System.Drawing.Printing;
using System.IO;
using System.Drawing.Imaging;
using mgh;
using System.Data.OleDb;

namespace Personal
{
    public partial class frm_Anneal : Form
    {
        string Report_Path = System.Environment.CurrentDirectory.ToString();
        string Path;
        frm_ProgSetting frm = new frm_ProgSetting();
        private System.IO.Stream streamToPrint;
        string streamType;
        int sum = 0;
        int counter=0;
        SaveFileDialog SaveFile = new SaveFileDialog();
        OpenFileDialog ofd = new OpenFileDialog();
        ListBox lb = new ListBox();
        [System.Runtime.InteropServices.DllImportAttribute("gdi32.dll")]
        private static extern bool BitBlt
            (
                IntPtr hdcDest,
                int nXDest,
                int nYDest,
                int nWidth,
                int nHeights,
                IntPtr hdcSrc,
                int nXSrc,
                int nYSrc,
                System.Int32 dwRop
             );
        public frm_Anneal()
        {
            InitializeComponent();
        }
        private void timer_Write_Tick(object sender, EventArgs e)
        {
            if (counter < 86)
            {
                SendKeys.Send("{TAB}");
                this.ActiveControl.Focus();
                if ((counter == 8) || (counter == 20) || (counter == 32) || (counter == 44) || (counter == 56))
                    try
                    {
                        sum += int.Parse(this.ActiveControl.Text);
                    }
                    catch  { }
                FileStream fs = new FileStream(Path, FileMode.Append, FileAccess.Write, FileShare.Read);
                StreamWriter sw = new StreamWriter(fs);
                sw.WriteLine(this.ActiveControl.Text);
                sw.Close();
                counter++;
            }
            else
            {

                timer_Write.Enabled = false;
                FileStream fs = new FileStream(Path, FileMode.Create, FileAccess.Write, FileShare.Read);
                StreamWriter sw = new StreamWriter(fs);
                sw.WriteLine(sum.ToString());
                maskedTextBox1.Text = sum.ToString();
                sw.Close();
                FarsiMessagbox.Show("ثبت فرم شارژ با موفقیت انجام گردید", "ثبت فرم شارژ", FMessageBoxButtons.Ok, FMessageBoxIcon.Information);

            }
        }
        private void timer_Read_Tick(object sender, EventArgs e)
        {
            if (counter <lb.Items.Count-1)
            {
                SendKeys.Send("{TAB}");
                this.ActiveControl.Text =lb.Items[counter].ToString();
                counter++; 
            }
            else
            {

                timer_Read.Enabled = false;
                FarsiMessagbox.Show("فراخوانی فرم شارژ با موفقیت انجام گردید", "فراخونی فرم شارژ", FMessageBoxButtons.Ok, FMessageBoxIcon.Information);

            }
        }
        public void  StartPrint(Stream streamToPrint, string streamType)
        {
            
            this.printDocument1.PrintPage += new PrintPageEventHandler(printDocument1_PrintPage);
            this.streamToPrint = streamToPrint;
            this.streamType = streamType;
            System.Windows.Forms.PrintDialog printDialog1 = new PrintDialog();
            printDialog1.AllowSomePages = true;
            printDialog1.ShowHelp = true;
            printDialog1.Document = printDocument1;
            DialogResult result = printDialog1.ShowDialog();
            if (result == DialogResult.OK)
            {
                
                printPreviewDialog1.Document = printDocument1;
                printPreviewDialog1.ShowDialog();
             //   printDocument1.Print();

            }

        }
        private void printDocument1_PrintPage(System.Object sender, System.Drawing.Printing.PrintPageEventArgs e)
        {
            System.Drawing.Image image = System.Drawing.Image.FromStream(this.streamToPrint);
            int x = e.MarginBounds.X;
            int y = e.MarginBounds.Y;
            int width = image.Width;
            int height = image.Height;
            if ((width / e.MarginBounds.Width) > (height / e.MarginBounds.Height))
            {
                width = e.MarginBounds.Width;
                height = image.Height * e.MarginBounds.Width / image.Width;
            }
            else
            {
                height = e.MarginBounds.Height;
                width = image.Width * e.MarginBounds.Height / image.Height;
            }
            System.Drawing.Rectangle destRect = new System.Drawing.Rectangle(x, y, width, height);
            e.Graphics.DrawImage(image, destRect, 0, 0, image.Width, image.Height, System.Drawing.GraphicsUnit.Pixel);
        }
        private void Save_Form_Click(object sender, EventArgs e)
        {
            //===============
            maskedTextBox22.Text = maskedTextBox20.Text = maskedTextBox5.Text;
            maskedTextBox27.Text = maskedTextBox19.Text = maskedTextBox6.Text;
            maskedTextBox37.Text = maskedTextBox18.Text = maskedTextBox8.Text;
            maskedTextBox47.Text = maskedTextBox17.Text = maskedTextBox7.Text;
            maskedTextBox57.Text = maskedTextBox16.Text = maskedTextBox9.Text;
            //===============
            SaveFile.DefaultExt = ID.Text;
            SaveFile.FileName = ID.Text;
            SaveFile.Filter = "INI File (*.Gr)|*.Gr";
            SaveFile.ShowDialog();
            Path = SaveFile.FileName;
            if (Path != "")
            {
                maskedTextBox4.Focus();
                counter = 0;
                timer_Write.Enabled = true;
            }
        }
        private void Load_Form_Click(object sender, EventArgs e)
        {
            lb.Items.Clear();
            ofd.Multiselect = false;
            ofd.InitialDirectory = Environment.SpecialFolder.Desktop.ToString();
            ofd.Filter = "INI files (*.Gr)|*.Gr";
            ofd.RestoreDirectory = true;
            ofd.ShowDialog();
            Path = ofd.FileName;
            FileStream fs = new FileStream(Path, FileMode.Open, FileAccess.Read, FileShare.Read);
            StreamReader sw = new StreamReader(fs);
            if (Path != "")
            {
                while (sw.EndOfStream == false)
                    lb.Items.Add(sw.ReadLine());
                counter = 0;
                maskedTextBox4.Focus();
                timer_Read.Enabled = true;
            }
        }
        private void Print_Form_Click(object sender, EventArgs e)
        {
            contextMenuStrip1.Hide();
            Graphics g1 = this.CreateGraphics();
            Image MyImage = new Bitmap(this.ClientRectangle.Width, this.ClientRectangle.Height, g1);
            Graphics g2 = Graphics.FromImage(MyImage);
            IntPtr dc1 = g1.GetHdc();
            IntPtr dc2 = g2.GetHdc();
            BitBlt(dc2, 0, 0, this.ClientRectangle.Width, this.ClientRectangle.Height, dc1, 0, 0, 13369376);
            g1.ReleaseHdc(dc1);
            g2.ReleaseHdc(dc2);
            MyImage.Save(@Report_Path, System.Drawing.Imaging.ImageFormat.Jpeg);
            FileStream filestream = new FileStream(@Report_Path, FileMode.Open, FileAccess.Read);
            StartPrint(filestream, "Image");
        }
        private void ثبتنهاییاطلاعاتآنیلToolStripMenuItem_Click(object sender, EventArgs e)
        {
            SaveFile.DefaultExt = ID.Text;
            SaveFile.FileName = ID.Text;
            SaveFile.Filter = "INI File (*.Gr)|*.Gr";
            SaveFile.ShowDialog();
            Path = SaveFile.FileName;
            if (Path != "")
            {
                maskedTextBox4.Focus();
                counter = 0;
                timer_Write.Enabled = true;
            }
        }
        private void frm_Anneal_Load(object sender, EventArgs e)
        {
            DataBase();
        }
        private void DataBase()
        {
        }
    }
}
