﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using mgh;
namespace Personal
{
    public partial class frm_CGL : Form
    {
        ConnectionClass con = new ConnectionClass();
        string curentUser;
        public frm_CGL(string PerNo)
        {
            InitializeComponent();
            txt_pri.Text= con.Back_Query("select family from login where per='" + PerNo + "'");
            curentUser = txt_pri.Text;

        }
        private void btnExportToExcel_Click(object sender, EventArgs e)
        {
            SaveFileDialog sfdExportToxcel = new SaveFileDialog();
            Tools.ExportToExcel.ExportToExcel exp = new Tools.ExportToExcel.ExportToExcel();
            sfdExportToxcel.FileName = "CGL.xls";
            sfdExportToxcel.Filter = "Archivos Excel (*.xls)|*.xls|Todos los Archivos (*.*)|*.*";
            sfdExportToxcel.FilterIndex = 1;
            sfdExportToxcel.RestoreDirectory = true;
            if (sfdExportToxcel.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                string path = sfdExportToxcel.FileName;
                exp.dataGridView2Excel(this.dataGridView1, path, "NameSheet");
            }
            FarsiMessagbox.Show("عملیات با موفقیت انجام گردید", "تبدیل به اکسل", FMessageBoxButtons.Ok, FMessageBoxIcon.Information);

        }
        private void toolStripButton1_Click(object sender, EventArgs e)
        {
            Print prt = new Print();
            prt.PrintDataGrid(dataGridView1, "گزارش کنترل ضایعات خط ریورس", "سیستم جامع واحد بهره برداری");

        }
        private void frm_CGL_Load(object sender, EventArgs e)
        {
            Date_ dt = new Date_();
            txt_date.Text = dt.Now();
            con.Load_Combo("select DISTINCT cause from cgl", txt_cause);
            con.View("select id as[ردیف],date_ as[تاریخ],pri as[تهیه کننده],shift_ as[شیفت],group_ as[گروه],no_coil as[شماره کوئل],height as[عرض],tick as[ضخامت],len as[متراژ],width as[وزن],cause as[ضایعات],des as[ملاحظات] from cgl",dataGridView1);
        }
        private void toolStripButton3_Click(object sender, EventArgs e)
        {
            con.ExecuteNonQuery("insert into cgl(date_,pri,shift_,group_,no_coil,height,tick,len,width,cause,des)values('"+txt_date.Text+"','"+curentUser+"','"+txt_shift.Text+"','"+txt_group.Text +"','"+txt_coil.Text+"','"+txt_height.Text +"','"+txt_tick.Text+"','"+txt_len.Text+"','"+txt_width.Text+"','"+txt_cause.Text+"','"+txt_dis.Text+"')");
            con.View("select id as[ردیف],date_ as[تاریخ],pri as[تهیه کننده],shift_ as[شیفت],group_ as[گروه],no_coil as[شماره کوئل],height as[عرض],tick as[ضخامت],len as[متراژ],width as[وزن],cause as[ضایعات],des as[ملاحظات] from cgl", dataGridView1);

        }
        private void dataGridView1_CellClick(object sender, DataGridViewCellEventArgs e)
        {
            lbl_id.Text = dataGridView1[0, e.RowIndex].Value.ToString();
            txt_date.Text = dataGridView1[1, e.RowIndex].Value.ToString();
            txt_pri.Text = dataGridView1[2, e.RowIndex].Value.ToString();
            txt_shift.Text = dataGridView1[3, e.RowIndex].Value.ToString();
            txt_group.Text = dataGridView1[4, e.RowIndex].Value.ToString();
            txt_coil.Text = dataGridView1[5, e.RowIndex].Value.ToString();
            txt_height.Text = dataGridView1[6, e.RowIndex].Value.ToString();
            txt_tick.Text = dataGridView1[7, e.RowIndex].Value.ToString();
            txt_len.Text = dataGridView1[8, e.RowIndex].Value.ToString();
            txt_width.Text = dataGridView1[9, e.RowIndex].Value.ToString();
            txt_cause.Text = dataGridView1[10, e.RowIndex].Value.ToString();
            txt_dis.Text = dataGridView1[11, e.RowIndex].Value.ToString();
        }
        private void toolStripButton2_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("آیا رکورد حذف شود", "حذف رکورد", MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.Yes)
            {
                con.ExecuteNonQuery("delete from cgl where id='"+lbl_id.Text+"'");
                con.View("select id as[ردیف],date_ as[تاریخ],pri as[تهیه کننده],shift_ as[شیفت],group_ as[گروه],no_coil as[شماره کوئل],height as[عرض],tick as[ضخامت],len as[متراژ],width as[وزن],cause as[ضایعات],des as[ملاحظات] from cgl", dataGridView1);

            }
        }
        private void txt_len_Leave(object sender, EventArgs e)
        {
            double hight, tick, len, with;
            try
            {
                hight = double.Parse(txt_height.Text);
                tick = double.Parse(txt_tick.Text);
                len = double.Parse(txt_len.Text);
                with = (hight * tick * len * 7.86) / 100000;
                txt_width.Text  = with.ToString();
            }
            catch
            {
                FarsiMessagbox.Show("اطلاعات ورودی جهت محاسبه وزن معتبر نمی باشد", "خطای اطلاعات", FMessageBoxButtons.Ok, FMessageBoxIcon.Stop);
            }
        }
        private void toolStripButton4_Click(object sender, EventArgs e)
        {
            Date_ dt = new Date_();
            string CurentDate = dt.Year_ + "/" + Microsoft.VisualBasic.Interaction.InputBox("شماره ماه را وارد نمائید", "گزارش کیفیت در دریورس ", dt.Month_, this.Height / 2, this.Width / 2);
            string Query = "SELECT  cause,cOUNT(width) AS Expr1 FROM  cgl where date_ like '" + CurentDate + "%' GROUP BY cause ";
            frm_chart frm = new frm_chart(Query, "گزارش تفکیک ضایعات ماه " + dt.Month_);
            frm.ShowDialog();
        }

        private void txt_len_TextChanged(object sender, EventArgs e)
        {
            double hight, tick, len, with;
            try
            {
                hight = double.Parse(txt_height.Text);
                tick = double.Parse(txt_tick.Text);
                len = double.Parse(txt_len.Text);
                with = (hight * tick * len * 7.86) / 100000;
                txt_width.Text = with.ToString();
            }
            catch
            {
                txt_width.Text = "0";
            }
        }


    }
}
