﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using mgh;

namespace Personal
{
    public partial class frm_Gerade_Karabeh_monthly : Form
    {
        ConnectionClass con = new ConnectionClass();
        string Query;
        string group_;
        string PerNo;
        double multi;
        public frm_Gerade_Karabeh_monthly(string username)
        {
            InitializeComponent();
            txt_semat.Text = con.Back_Query("SELECT SEMAT FROM INFO WHERE PER='" + username + "'");
            desiner.Text = con.Back_Query("SELECT FAMILY FROM LOGIN WHERE PER='" + username + "'");
            group_ = con.Back_Query("SELECT group_ FROM info WHERE PER='" + username + "'");
            txt_area.Text = con.Back_Query("SELECT area FROM info WHERE PER='" + username + "'");
            PerNo = username;
            if (username == "313064")
            {
                buttonX2.Enabled = true;
            }
        }
        private void frm_Gerade_Karabeh_monthly_Load(object sender, EventArgs e)
        {
            FarsiMessagbox.Show("شما تنها به پرسنلی می توانید نمره بدهید که نمرات سرشیفت یا کارشناس آنها داده شده باشد", "پیغام", FMessageBoxButtons.Ok);
            con.Load_Combo("select DISTINCT semat from info", comboBox1);
            txt_month.Items.Add("فروردین"); txt_month.Items.Add("اردیبهشت");
            txt_month.Items.Add("خرداد"); txt_month.Items.Add("تیر");
            txt_month.Items.Add("مرداد"); txt_month.Items.Add("شهریور");
            txt_month.Items.Add("مهر"); txt_month.Items.Add("آبان");
            txt_month.Items.Add("آذر"); txt_month.Items.Add("دی");
            txt_month.Items.Add("بهمن"); txt_month.Items.Add("اسفند");
            //=================================================================
            System.Globalization.PersianCalendar x = new System.Globalization.PersianCalendar();
            x.GetYear(System.DateTime.Now);
            txt_date.Text = x.GetYear(System.DateTime.Now).ToString() + "/" + x.GetMonth(System.DateTime.Now).ToString() + "/" + x.GetDayOfMonth(System.DateTime.Now).ToString();


         }
        private void Kershenas()
        {
            string x="";
            if (comboBox1.Text == "اپراتور") x = comboBox1.Text;
             con.View("select max(per) as[ردیف],info.fname+' '+info.lname as[نام و نام خانوادگی],min(info.per) as[امتیاز نهایی ] " +
            " from gerade,info " +
            " where info.semat='" +x+ "' " +
            " and info.area='" + txt_area.Text + "' " +
            " group by info.fname+' '+info.lname", dataGridView1);

             if (comboBox1.Text == "سرشيفت") x = comboBox1.Text;
             con.View("select max(per) as[ردیف],info.fname+' '+info.lname as[نام و نام خانوادگی],min(info.per) as[امتیاز نهایی ] " +
            " from gerade,info " +
            " where info.semat='" + x + "' " +
            " and info.area='" + txt_area.Text + "' " +
            " group by info.fname+' '+info.lname", dataGridView1);  

        }
        private void Boss()
        {

            if (comboBox1.Text == "")
                MessageBox.Show("گروه شغلی را انتخاب نمائبد", "خطا", MessageBoxButtons.OK, MessageBoxIcon.Information);
            else 
            {
                if (comboBox1.Text == "اپراتور") Boss_Operator();
                if (comboBox1.Text == "سرشيفت") Boss_Forman();
                if (comboBox1.Text == "کارشناس") Boss_Karshenas();
            }
        }
        private void Manager()
        {
            if (comboBox1.Text == "اپراتور") Manger_OP();
            if (comboBox1.Text == "سرشيفت") Mnager_Forman();
            if (comboBox1.Text == "کارشناس") manager_Kar();
            if (comboBox1.Text == "منشي مديريت") Manager_Monshi();
        }
        private void Boss_Operator()
        {
            con.View("select max(per) as[ردیف],info.fname+' '+info.lname as[نام و نام خانوادگی],min(info.per) as[امتیاز نهایی ],avg(gerade.gerade) as [میانگین امتیاز] " +
            " from gerade,info " +
            " where info.semat='" + "اپراتور" + "' " +
            " and gerade.personal=info.fname+' '+info.lname" +
            " and info.area='" + txt_area.Text + "' " +
            " and gerade.month_='"+txt_month.Text +"'"+
            " group by info.fname+' '+info.lname", dataGridView1);

        }
        private void Boss_Forman()
        {
            con.View("select max(per) as[ردیف],info.fname+' '+info.lname as[نام و نام خانوادگی],min(info.per) as[امتیاز نهایی ],avg(gerade.gerade) as [میانگین امتیاز] " +
         " from gerade,info " +
         " where info.semat='" + "سرشیفت" + "' " +
         " and gerade.personal=info.fname+' '+info.lname" +
         " and info.area='" + txt_area.Text + "' " +
         " and gerade.month_='" + txt_month.Text + "'" +
         " group by info.fname+' '+info.lname", dataGridView1); 

        }
        private void Boss_Karshenas()
        {
            con.View("select max(per) as[ردیف],info.fname+' '+info.lname as[نام و نام خانوادگی],min(info.per) as[امتیاز نهایی ] " +
         " from gerade,info " +
         " where info.semat='" + "کارشناس" + "' " +
         " and info.area='" + txt_area.Text + "' " +
         " group by info.fname+' '+info.lname", dataGridView1);        

        }
        private void buttonX1_Click(object sender, EventArgs e)
        {
            if (txt_month.Text == "")
                MessageBox.Show("فیلد تاریخ یا ماه معتبر نمی باشد", "خطا در ثبت", MessageBoxButtons.OK, MessageBoxIcon.Information);
            {
                if (txt_semat.Text == "مدیر") Manager();
                if (txt_semat.Text == "رئيس") Boss();
                if (txt_semat.Text == "کارشناس") Kershenas();
                for (int i = 0; i < dataGridView1.RowCount - 1; i++)
                {
                    dataGridView1[0, i].Value = (i + 1).ToString();
                    dataGridView1[2, i].Value = "0";
                }
            }
        }
        private void Manger_OP()
        {
            con.View("select max(per) as[ردیف],fname+' '+lname as[نام و نام خانوادگی],min(per) as[امتیاز نهایی ] " +
            " from info " +
            " where semat='" + "اپراتور" + "' " +
            " group by fname+' '+lname ", dataGridView1);
        }
        private void manager_Kar()
        {
            con.View("select max(per) as[ردیف],fname+' '+lname as[نام و نام خانوادگی],min(per) as[امتیاز نهایی ] " +
            " from info " +
            " where semat='" + "کارشناس" + "' " +
            " group by fname+' '+lname ", dataGridView1);
        }
        private void Manager_Monshi()
        {
            con.View("select max(per) as[ردیف],fname+' '+lname as[نام و نام خانوادگی],min(per) as[امتیاز نهایی ] " +
            " from info " +
            " where semat='" + "منشي مديريت" + "' " +
            " group by fname+' '+lname ", dataGridView1);
        }
        private void Mnager_Forman()
        {
            con.View("select max(per) as[ردیف],fname+' '+lname as[نام و نام خانوادگی],min(per) as[امتیاز نهایی ] " +
            " from info " +
            " where semat='" + "سرشيفت" + "' " +
            " group by fname+' '+lname ", dataGridView1);
        }
        private void btn_ADD_Click(object sender, EventArgs e)
        {
           if((txt_month.Text=="")||(txt_date.Text==""))
                MessageBox.Show("فیلد تاریخ یا ماه معتبر نمی باشد","خطا در ثبت",MessageBoxButtons.OK,MessageBoxIcon.Information);
            else
            {//محاسبه امتیاز
                for (int i = 0; i < dataGridView1.RowCount - 1; i++)
                    dataGridView1[2, i].Value =  (double.Parse(dataGridView1[2, i].Value.ToString())*multi)/100;
               //ثبت امتیاز شیفت فورمن در جدول نهایی
                try
                {
                    for (int i = 0; i < dataGridView1.RowCount - 1; i++)
                        con.Back_Query("update final_gerade set forman='" + dataGridView1[3, i].Value.ToString() + "' where (per='" + dataGridView1[1, i].Value.ToString() + "' and month_='" + txt_month.Text + "')");
                }
                catch { //این درج امتیاز پرسنلی فقط برای رئیس می باشد
                }
              if (txt_semat.Text == "مدیر")
              {

                    for (int i = 0; i < dataGridView1.RowCount - 1; i++)
                        con.Back_Query("update final_gerade set manager='" + dataGridView1[2, i].Value.ToString() + "',date_='" + txt_date.Text + "' where (per='" + dataGridView1[1, i].Value.ToString() + "' and month_='" + txt_month.Text + "')");
                    FarsiMessagbox.Show("عملیات تغییر با موفقیت انجام گردید", "SevenDiamonds.Co", FMessageBoxButtons.Ok, FMessageBoxIcon.Information);
                }
              if (txt_semat.Text == "رئيس")
                {
                      for (int i = 0; i < dataGridView1.RowCount - 1; i++)
                          con.Back_Query("update final_gerade set boss='" + dataGridView1[2, i].Value.ToString() + "',date_='" + txt_date.Text + "'  where (per='" + dataGridView1[1, i].Value.ToString() + "' and month_='" + txt_month.Text + "')");
                    FarsiMessagbox.Show("عملیات تغییر با موفقیت انجام گردید", "SevenDiamonds.Co", FMessageBoxButtons.Ok, FMessageBoxIcon.Information);
                }
                if (txt_semat.Text == "کارشناس")
                {
                    for (int i = 0; i < dataGridView1.RowCount - 1; i++)
                        con.Back_Query("update final_gerade set karshenas='" + dataGridView1[2, i].Value.ToString() + "',date_='" + txt_date.Text + "'  where (per='" + dataGridView1[1, i].Value.ToString() + "' and month_='" + txt_month.Text + "')");
                    FarsiMessagbox.Show("عملیات تغییر با موفقیت انجام گردید", "SevenDiamonds.Co", FMessageBoxButtons.Ok, FMessageBoxIcon.Information);
                }
                label9.Text = "";
            }
        }
        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            string val = con.Back_Query("select val from grant_ where sender='" + txt_semat.Text + "' and resiver='" + comboBox1.Text + "'");
            multi = double.Parse(val);
        }
        private void buttonX3_Click(object sender, EventArgs e)
        {
            string sql_ = "select info.fname+' '+info.lname as[نام و نام خانوادگی],avg(gerade.gerade) as [میانگین امتیاز] " +
         " from gerade,info " +
         " where info.semat='" + comboBox1.Text+ "' " +
         " and gerade.personal=info.fname+' '+info.lname" +
         " and info.area='" + txt_area.Text + "' " +
         " and gerade.month_='" + txt_month.Text + "'" +
         " group by info.fname+' '+info.lname";
          frm_chart frm = new frm_chart(sql_,"گزارش امتیاز پرسنل");
            frm.ShowDialog();
        }
        private void textBox1_KeyDown(object sender, KeyEventArgs e)
        {

                if (e.KeyCode == Keys.Return)
                {
                   if (txt_month.Text == "")
                          MessageBox.Show("فیلد تاریخ یا ماه معتبر نمی باشد", "خطا در ثبت", MessageBoxButtons.OK, MessageBoxIcon.Information);
                     else
                 {
                    if(radioButton1.Checked==true)Query="select id as [ردیف],desiner as[امتیاز دهنده],date_ as [تاریخ],gerade as[امتیاز] from gerade where personal in(select fname+' '+lname from info where per='" + textBox1.Text + "') and month_='"+txt_month.Text+"'";
                    if (radioButton2.Checked == true) Query = "select id as [ردیف],personal as[امتیاز شونده],date_ as [تاریخ],gerade as[امتیاز] from gerade where desiner in(select fname+' '+lname from info where per='" + textBox1.Text + "') and month_='" + txt_month.Text + "'";
                    con.View(Query, dataGridView1); 
                    fname.Text = con.Back_Query("select fname from info where per='" + textBox1.Text + "'");
                    lname.Text = con.Back_Query("select lname from info where per='" + textBox1.Text + "'");
                 }
                }
            }
        private void buttonX2_Click(object sender, EventArgs e)
        {
            if (txt_month.Text != "")
            {
                if(con.Back_Query("select per from final_gerade where month_='"+txt_month.Text +"'")=="error")
                {
                DataGridView db = new DataGridView();
                db.Name = "db";
                this.Controls.Add(db);
                db.Visible = false;
                con.View("select fname+' '+lname from info", db);
                for (int i = 0; i < db.Rows.Count - 1; i++)
                    con.Back_Query("insert into final_gerade (per,month_) values('" + db[0, i].Value.ToString() + "','" + txt_month.Text + "')");
                FarsiMessagbox.Show("تنظیمات نهایی برای ماه فوق انجام گردید", "تنظیمات نهایی امتیاز", FMessageBoxButtons.Ok, FMessageBoxIcon.Information);
                }
                else
                    FarsiMessagbox.Show("تنظیمات ماه فوق انجام شده است و شما مجاز به تنظیم دوباره نمی باشید", "تنظیمات نهایی امتیاز", FMessageBoxButtons.Ok, FMessageBoxIcon.Information);
            }
            else
                FarsiMessagbox.Show("ماه مورد نظر را انتخاب نمایید", "تنظیمات نهایی امتیاز", FMessageBoxButtons.Ok, FMessageBoxIcon.Information);

        }
    }
    }

