﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Personal
{
    public partial class frm_Later : Form
    {
        ConnectionClass con = new ConnectionClass();
        public frm_Later()
        {
            InitializeComponent();
        }
        private void frm_Later_Load(object sender, EventArgs e)
        {
            con.Load_Combo("select DISTINCT sender from latter", txt_sender);
            con.Load_Combo("select DISTINCT resiver from latter", txt_resiver);
            con.View("select no_latter as[شماره نامه],date_latter as[تاریخ],attach as[پیوست],sender as[فرستنده],resiver as[گیرنده],subject as[موضوع/چکیده] from latter", kryptonDataGridView1);
            kryptonDataGridView1.Columns[0].Width = 80;
            kryptonDataGridView1.Columns[1].Width = 100;
            kryptonDataGridView1.Columns[2].Width = 80;
            kryptonDataGridView1.Columns[3].Width = 100;
            kryptonDataGridView1.Columns[4].Width = 100;
            txt_end_no.Text = con.Back_Query("select max(no_latter) from latter");
        }
        private void toolStripButton3_Click(object sender, EventArgs e)
        {
            con.ExecuteNonQuery("insert into latter values('"+txt_no.Text +"','"+txt_date.Text +"','"+txt_attach.Text +"','"+txt_sender.Text +"','"+txt_resiver.Text+"','"+txt_sebject.Text+"')");
            txt_sebject.Clear();
            txt_no.Clear();
            txt_date.Clear();
            txt_attach.Clear();
            con.View("select no_latter as[شماره نامه],date_latter as[تاریخ],attach as[پیوست],sender as[فرستنده],resiver as[گیرنده],subject as[موضوع/چکیده] from latter", kryptonDataGridView1);
            txt_end_no.Text = con.Back_Query("select max(no_latter) from latter");


        }
        private void btnExportToExcel_Click(object sender, EventArgs e)
        {
            SaveFileDialog sfdExportToxcel = new SaveFileDialog();
            Tools.ExportToExcel.ExportToExcel exp = new Tools.ExportToExcel.ExportToExcel();
            sfdExportToxcel.FileName = "گزارش دفتر اندیکاتور.xls";
            sfdExportToxcel.Filter = "Archivos Excel (*.xls)|*.xls|Todos los Archivos (*.*)|*.*";
            sfdExportToxcel.FilterIndex = 1;
            sfdExportToxcel.RestoreDirectory = true;

            if (sfdExportToxcel.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                string path = sfdExportToxcel.FileName;
                exp.dataGridView2Excel(this.kryptonDataGridView1, path, "NameSheet");
            } 
        }
        private void kryptonDataGridView1_CellClick(object sender, DataGridViewCellEventArgs e)
        {
           txt_no.Text = kryptonDataGridView1[0, kryptonDataGridView1.CurrentRow.Index ].Value.ToString();
           txt_date.Text = kryptonDataGridView1[1, kryptonDataGridView1.CurrentRow.Index].Value.ToString();
           txt_sender.Text = kryptonDataGridView1[3, kryptonDataGridView1.CurrentRow.Index].Value.ToString(); ;
           txt_resiver.Text = kryptonDataGridView1[4, kryptonDataGridView1.CurrentRow.Index].Value.ToString(); ;
           txt_attach.Text = kryptonDataGridView1[2, kryptonDataGridView1.CurrentRow.Index].Value.ToString(); ;
           txt_sebject.Text = kryptonDataGridView1[5, kryptonDataGridView1.CurrentRow.Index].Value.ToString();
        }

        private void toolStripButton2_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("آیا رکورد فوق حذف گردد", "حذف رکورد", MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.Yes)
            {
                con.ExecuteNonQuery("delete from latter where no_latter='"+txt_no.Text+"'");
                con.View("select no_latter as[شماره نامه],date_latter as[تاریخ],attach as[پیوست],sender as[فرستنده],resiver as[گیرنده],subject as[موضوع/چکیده] from latter", kryptonDataGridView1);
                txt_end_no.Text = con.Back_Query("select max(no_latter) from latter");
            }
        }
    }
}
