﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using mgh;

namespace Personal
{
    public partial class frm_personal : Form
    {
        ConnectionClass con = new ConnectionClass();
 
        public frm_personal()
        {
            InitializeComponent();
        }

        private void pERSONAL_Load(object sender, EventArgs e)
        {
            con.Load_Combo("select DISTINCT semat from info ", txt_semat);
            con.Load_Combo("select DISTINCT area from info ", txt_area);
            con.Load_Combo("select DISTINCT Group_ from info ",txt_group );
            con.Load_Combo("select DISTINCT number_shift from info ", txt_shift);
            con.Load_Combo("select UNIT from UNIT ", txt_part);
            con.View("select per as [ردیف],per as[شماره پرسنلی],fname as[نام],lname as[نام خانوادگی],area as[ناحیه],part as[واحد سازمانی],group_ as[گروه],number_shift as[نوع شیفت],tel as [تلفن],semat as[سمت شغلی],madrak as[مقطع تحصیلی],gerayesh as[مدرک تحصیلی] from info ", dataGridView1);
            dataGridView1.Columns[0].Width = 30;
            dataGridView1.Columns[1].Width =70;
            dataGridView1.Columns[3].Width = 90;
            dataGridView1.Columns[4].Width = 35;
            dataGridView1.Columns[5].Width = 90;
            dataGridView1.Columns[7].Width = 35;
            dataGridView1.Columns[6].Width = 35;
            dataGridView1.Columns[8].Width = 80;
            dataGridView1.Columns[9].Width = 60;
            for (int i = 1; i < dataGridView1.Rows.Count; i++)
                dataGridView1[0, i - 1].Value = i.ToString();
        }
        private void dataGridView1_CellClick_1(object sender, DataGridViewCellEventArgs e)
        {
            txt_per.Text = dataGridView1[1, dataGridView1.CurrentRow.Index].Value.ToString();
            txt_fname.Text = dataGridView1[2, dataGridView1.CurrentRow.Index].Value.ToString();
            txt_lname.Text = dataGridView1[3, dataGridView1.CurrentRow.Index].Value.ToString();
            txt_area.Text = dataGridView1[4, dataGridView1.CurrentRow.Index].Value.ToString();
            txt_part.Text = dataGridView1[5, dataGridView1.CurrentRow.Index].Value.ToString();
            txt_group.Text  = dataGridView1[6, dataGridView1.CurrentRow.Index].Value.ToString();
            txt_shift.Text  = dataGridView1[7, dataGridView1.CurrentRow.Index].Value.ToString();
            txt_tel.Text  = dataGridView1[8, dataGridView1.CurrentRow.Index].Value.ToString();
            txt_semat.Text = dataGridView1[9, dataGridView1.CurrentRow.Index].Value.ToString();
            txt_madrak.Text= dataGridView1[10, dataGridView1.CurrentRow.Index].Value.ToString();
            txt_gerayesh.Text = dataGridView1[11, dataGridView1.CurrentRow.Index].Value.ToString();
           
        }
        private void toolStripButton1_Click(object sender, EventArgs e)
        {
            Print prt = new Print();
            prt.PrintDataGrid(dataGridView1, "لیست پرسنل", "واحد بهره برداری");
        }
        private void toolStripButton3_Click(object sender, EventArgs e)
        {
            con.ExecuteNonQuery("insert into info (per,fname,lname,area,part,tel,semat,Group_,number_shift,madrak,gerayesh) values ('" + txt_per.Text + "','" + txt_fname.Text + "','" + txt_lname.Text + "','" + txt_area.Text + "','" + txt_part.Text + "','" + txt_tel.Text + "','" + txt_semat.Text + "','" + txt_group.Text + "','" + txt_shift.Text + "','" + txt_madrak.Text + "','" + txt_gerayesh.Text + "')");
        }
        private void toolStripButton2_Click(object sender, EventArgs e)
        {
            if(FarsiMessagbox.Show("آیا پرسنل جاری حذف گردد؟","حذف پرسنل",FMessageBoxButtons.YesNo,FMessageBoxIcon.Question)==DialogResult.Yes)
            con.ExecuteNonQuery("delete from info where per='" + txt_per.Text+ "'");
            con.View("select per as [ردیف],per as[شماره پرسنلی],fname as[نام],lname as[نام خانوادگی],area as[ناحیه],part as[واحد سازمانی],group_ as[گروه],number_shift as[نوع شیفت],tel as [تلفن],semat as[سمت شغلی],madrak as[مقطع تحصیلی],gerayesh as[مدرک تحصیلی] from info ", dataGridView1);


        }
        private void btnExportToExcel_Click(object sender, EventArgs e)
        {
            SaveFileDialog sfdExportToxcel = new SaveFileDialog();
            Tools.ExportToExcel.ExportToExcel exp = new Tools.ExportToExcel.ExportToExcel();
            sfdExportToxcel.FileName = "Personal.xls";
            sfdExportToxcel.Filter = "Archivos Excel (*.xls)|*.xls|Todos los Archivos (*.*)|*.*";
            sfdExportToxcel.FilterIndex = 1;
            sfdExportToxcel.RestoreDirectory = true;

            if (sfdExportToxcel.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                string path = sfdExportToxcel.FileName;
                exp.dataGridView2Excel(this.dataGridView1, path, "گزارش پرسنلی");
            }
        }
        private void toolStripTextBox1_TextChanged(object sender, EventArgs e)
        {
            con.View("select per as [ردیف],per as[شماره پرسنلی],fname as[نام],lname as[نام خانوادگی],area as[ناحیه],part as[واحد سازمانی],group_ as[گروه],number_shift as[نوع شیفت],tel as [تلفن],semat as[سمت شغلی],madrak as[مقطع تحصیلی],gerayesh as[مدرک تحصیلی] from info where per like '" + toolStripTextBox1.Text + "%' order by part", dataGridView1);
            for (int i = 1; i < dataGridView1.Rows.Count; i++)
                dataGridView1[0, i - 1].Value = i.ToString();
        }
        private void toolStripButton4_Click(object sender, EventArgs e)
        {
            con.Back_Query("delete from info");
            for (int i = 0; i < dataGridView1.RowCount - 1; i++)
            {
                con.Back_Query("insert into info (per,fname,lname,area,part,Group_,number_shift,tel,semat,madrak,gerayesh)"
                +"values ("
                +" '" + dataGridView1[1,i].Value.ToString()+ "',"
                +" '" + dataGridView1[2,i].Value.ToString()+ "',"
                +" '" + dataGridView1[3,i].Value.ToString()+ "',"
                +" '" + dataGridView1[4,i].Value.ToString()+ "',"
                +" '" + dataGridView1[5,i].Value.ToString()+ "',"
                +" '" + dataGridView1[6,i].Value.ToString()+ "',"
                +" '" + dataGridView1[7,i].Value.ToString()+ "',"
                +" '" + dataGridView1[8,i].Value.ToString()+ "',"
                +" '" + dataGridView1[9,i].Value.ToString()+ "',"
                +" '" + dataGridView1[10,i].Value.ToString()+ "',"
                + " '" + dataGridView1[11, i].Value.ToString() + "')");
             }
            FarsiMessagbox.Show("بروز رسانی اطلاعات با موفقیت انجام گردید"+"\n"+dataGridView1.RowCount.ToString()+"\t"+"تعداد رکورد"+"\t", "بروز رسانی داده ها", FMessageBoxButtons.Ok, FMessageBoxIcon.Information);
        }
        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {

        }

    }
}
