﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using mgh;

namespace Personal
{
    public partial class pERSONAL : Form
    {
        ConnectionClass con = new ConnectionClass();
 
        public pERSONAL()
        {
            InitializeComponent();
        }

        private void pERSONAL_Load(object sender, EventArgs e)
        {
            con.Load_Combo("select DISTINCT semat from info ", txt_semat);
            con.Load_Combo("select DISTINCT area from info ", txt_area);
            con.Load_Combo("select DISTINCT Group_ from info ",txt_group );
            con.Load_Combo("select DISTINCT number_shift from info ", txt_shift);
            con.Load_Combo("select DISTINCT PART from info ", txt_part);
            con.View("select per as [ردیف],per as[شماره پرسنلی],fname as[نام],lname as[نام خانوادگی],part as[واحد سازمانی],group_ as[گروه],number_shift as[نوع شیفت],tel as [تلفن],semat as[سمت شغلی] from info", dataGridView1);
            for (int i = 1; i < dataGridView1.Rows.Count; i++)
                dataGridView1[0, i - 1].Value = i.ToString();
        }


        private void dataGridView1_CellClick_1(object sender, DataGridViewCellEventArgs e)
        {
            txt_per.Text = dataGridView1[1, dataGridView1.CurrentRow.Index].Value.ToString();
            txt_fname.Text = dataGridView1[2, dataGridView1.CurrentRow.Index].Value.ToString();
            txt_lname.Text = dataGridView1[3, dataGridView1.CurrentRow.Index].Value.ToString();
            txt_part.Text = dataGridView1[4, dataGridView1.CurrentRow.Index].Value.ToString();
            txt_tel.Text = dataGridView1[7, dataGridView1.CurrentRow.Index].Value.ToString();
            txt_shift.Text  = dataGridView1[6, dataGridView1.CurrentRow.Index].Value.ToString();
            txt_group.Text = dataGridView1[5, dataGridView1.CurrentRow.Index].Value.ToString();
            txt_semat.Text = dataGridView1[8, dataGridView1.CurrentRow.Index].Value.ToString();
           
        }

        private void toolStripButton1_Click(object sender, EventArgs e)
        {
            Print prt = new Print();
            prt.PrintDataGrid(dataGridView1, "لیست پرسنل", "واحد بهره برداری");
        }

        private void toolStripButton3_Click(object sender, EventArgs e)
        {
            con.ExecuteNonQuery("insert into info (per,fname,lname,area,part,tel,semat,Group_,number_shift) values ('" + txt_per.Text + "','" + txt_fname.Text + "','" + txt_lname.Text + "','" + txt_area.Text + "','" + txt_part.Text + "','" + txt_tel.Text + "','" + txt_semat.Text + "','" + txt_group.Text + "','" + txt_shift.Text + "')");
            con.View("select per as [ردیف],per as[شماره پرسنلی],fname as[نام],lname as[نام خانوادگی],part as[واحد سازمانی],group_ as[گروه],number_shift as[نوع شیفت],tel as [تلفن],semat as[سمت شغلی] from info", dataGridView1);
            for (int i = 1; i < dataGridView1.Rows.Count; i++)
                dataGridView1[0, i - 1].Value = i.ToString();
        }

        private void toolStripButton2_Click(object sender, EventArgs e)
        {
            if(FarsiMessagbox.Show("آیا پرسنل جاری حذف گردد؟","حذف پرسنل",FMessageBoxButtons.YesNo,FMessageBoxIcon.Question)==DialogResult.Yes)
            con.ExecuteNonQuery("delete from info where per='" + txt_per.Text+ "'");

        }

        private void btnExportToExcel_Click(object sender, EventArgs e)
        {
            SaveFileDialog sfdExportToxcel = new SaveFileDialog();
            Tools.ExportToExcel.ExportToExcel exp = new Tools.ExportToExcel.ExportToExcel();
            sfdExportToxcel.FileName = "Personal.xls";
            sfdExportToxcel.Filter = "Archivos Excel (*.xls)|*.xls|Todos los Archivos (*.*)|*.*";
            sfdExportToxcel.FilterIndex = 1;
            sfdExportToxcel.RestoreDirectory = true;

            if (sfdExportToxcel.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                string path = sfdExportToxcel.FileName;
                exp.dataGridView2Excel(this.dataGridView1, path, "گزارش پرسنلی");
            }
        }

        private void toolStripTextBox1_TextChanged(object sender, EventArgs e)
        {
            con.View("select per as [ردیف],per as[شماره پرسنلی],fname as[نام],lname as[نام خانوادگی],part as[واحد سازمانی],group_ as[گروه],number_shift as[نوع شیفت],tel as [تلفن],semat as[سمت شغلی] from info where per like '" + toolStripTextBox1.Text + "%' order by part", dataGridView1);
            for (int i = 1; i < dataGridView1.Rows.Count; i++)
                dataGridView1[0, i - 1].Value = i.ToString();
        }





    }
}
